=== mir/share/CMakeLists.txt ===
add_subdirectory(mir)
