=== debian/changelog ===
metview (5.23.1-1build1) plucky; urgency=medium

  * No-change rebuild for libnetcdf22.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 20 Feb 2025 14:43:10 +0000

metview (5.23.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 24 Nov 2024 06:30:25 +0000
